<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CreatePickingTask StructType
 * @subpackage Structs
 */
class CreatePickingTask extends AbstractStructBase
{
    /**
     * The pickingTask
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \StructType\PickingTask
     */
    public $pickingTask;
    /**
     * The accessKey
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $accessKey;
    /**
     * Constructor method for CreatePickingTask
     * @uses CreatePickingTask::setPickingTask()
     * @uses CreatePickingTask::setAccessKey()
     * @param \StructType\PickingTask $pickingTask
     * @param string $accessKey
     */
    public function __construct(\StructType\PickingTask $pickingTask = null, $accessKey = null)
    {
        $this
            ->setPickingTask($pickingTask)
            ->setAccessKey($accessKey);
    }
    /**
     * Get pickingTask value
     * @return \StructType\PickingTask|null
     */
    public function getPickingTask()
    {
        return $this->pickingTask;
    }
    /**
     * Set pickingTask value
     * @param \StructType\PickingTask $pickingTask
     * @return \StructType\CreatePickingTask
     */
    public function setPickingTask(\StructType\PickingTask $pickingTask = null)
    {
        $this->pickingTask = $pickingTask;
        return $this;
    }
    /**
     * Get accessKey value
     * @return string|null
     */
    public function getAccessKey()
    {
        return $this->accessKey;
    }
    /**
     * Set accessKey value
     * @param string $accessKey
     * @return \StructType\CreatePickingTask
     */
    public function setAccessKey($accessKey = null)
    {
        // validation for constraint: string
        if (!is_null($accessKey) && !is_string($accessKey)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($accessKey, true), gettype($accessKey)), __LINE__);
        }
        $this->accessKey = $accessKey;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CreatePickingTask
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
